var vows = require( 'vows' ),
    assert = require( 'assert' ),
    equality = require( '../lib/equality' );

vows.describe( 'Equality' ).addBatch({

  'deep()': {

    topic: function () { return equality.deep; },

    'works for atomic values': function ( deep ) {
      assert.isTrue( deep( 1, 1 ) );
      assert.isFalse( deep( 1, 2 ) );

      assert.isTrue( deep( true, true ) );
      assert.isFalse( deep( true, false ) );

      assert.isTrue( deep( 'string', 'string' ) );
      assert.isFalse( deep( 'string', 'number' ) );

      assert.isFalse( deep( 1, { a: 2 } ) );
      assert.isFalse( deep( { a: 2 }, 1 ) );

      assert.isFalse( deep( true, { a: 2 } ) );
      assert.isFalse( deep( { a: 2 }, true ) );

      assert.isFalse( deep( 'string', { a: 2 } ) );
      assert.isFalse( deep( { a: 2 }, 'string' ) );
    },

    'works for objects with objects': function ( deep ) {
      var obj1 = { a: { b: 'c' }, d: { e: 'f' } },
          obj2 = { a: { b: 'c' }, d: { e: 'f' } },
          obj3 = { x: 10, y: { e: 'f' } };

      assert.isTrue( deep( obj1, obj2 ) );
      assert.isFalse( deep( obj2, obj3 ) );
      assert.isTrue( deep( obj1.d, obj3.y ) );
    }

  }

}).export( module );
